﻿<%@ Page Language="VB" AutoEventWireup="true" CodeFile="Default.aspx.vb" Inherits="_Default" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server" />
        <div>
            <telerik:RadCodeBlock ID="RadCodeBlock1" runat="server">
                <script type="text/javascript">
                <!--
                var HasChanges, inputs, lastChanged, editedRowIndex;

                function RowClick(sender, eventArgs)
                {
                    if(editedRowIndex != null && HasChanges)
                    {    
                        if(confirm("Update changes?"))
                        {
                            HasChanges = false;
                            eventArgs.get_tableView().updateItem(editedRowIndex); 
                        }
                        else
                        {
                            HasChanges = false;
                        }
                    }
                }

                function RowDblClick(sender, eventArgs)
                {                    
                    if(editedRowIndex && HasChanges)
                    {    
                        if(confirm("Update changes?"))
                        {
                            HasChanges = false;
                            eventArgs.get_tableView().updateItem(editedRowIndex); 
                        }
                        else
                        {
                            HasChanges = false;
                        }
                    }       
                    editedRowIndex = eventArgs.get_itemIndexHierarchical();                    
                    eventArgs.get_tableView().editItem(editedRowIndex);                      
                }

                function RowCreated(sender, eventArgs)
                {
                    inputs = sender.get_element().getElementsByTagName("input");
                    for (var i = 0; i < inputs.length;i++)
                    {
                        inputs[i].onchange = TrackChanges;
                    }
                    setTimeout(function(){inputs[0].focus();},100);                    
                }

                function RequestStart(e)
                {
                    var canRequest = true; 
                    if (HasChanges)
                    {
                        canRequest = confirm("Cancel changes?");
                    }

                    if(canRequest)
                    {
                        HasChanges = false;
                        return true;
                    }
                    else
                    {
                        lastChanged.select();
                        return false;
                    }
                }

                function TrackChanges(e)
                {
                    lastChanged = GetCurrentElement(e);
                    HasChanges = true;
                }

                function GetCurrentElement(e)
                {
                    if(!e)
                        var e = window.event;

                    if (e.srcElement)
                    {
                        return e.srcElement;
                    }

                    if(e.target)
                    {
                        return e.target;
                    }
                }
                -->
                </script>
            </telerik:RadCodeBlock>
        
            <asp:Label ID="Label1" runat="server"></asp:Label><br />
            <telerik:RadAjaxManager ID="RadAjaxManager1" runat="server">
                <AjaxSettings>
                    <telerik:AjaxSetting AjaxControlID="RadGrid1">
                        <UpdatedControls>
                            <telerik:AjaxUpdatedControl ControlID="Label1" />
                            <telerik:AjaxUpdatedControl ControlID="RadGrid1" />
                        </UpdatedControls>
                    </telerik:AjaxSetting>
                </AjaxSettings>                
            </telerik:RadAjaxManager>
            <telerik:RadGrid ID="RadGrid1" DataSourceID="AccessDataSource1" runat="server" Skin="Telerik"
                Width="95%" AutoGenerateColumns="False" PageSize="3" AllowPaging="True" GridLines="None"
                AllowAutomaticUpdates="True" OnItemUpdated="RadGrid1_ItemUpdated">
                <PagerStyle Mode="NumericPages"></PagerStyle>
                <MasterTableView DataSourceID="AccessDataSource1" Width="100%" AutoGenerateColumns="false"
                    DataKeyNames="CustomerID" EditMode="InPlace" Name="Customers" AllowAutomaticUpdates="true">
                    <DetailTables>
                        <telerik:GridTableView DataKeyNames="OrderID" DataSourceID="AccessDataSource2" Width="100%"
                            runat="server" AllowAutomaticUpdates="true" AutoGenerateColumns="false" EditMode="InPlace"
                            Name="Orders">
                            <ParentTableRelation>
                                <telerik:GridRelationFields DetailKeyField="CustomerID" MasterKeyField="CustomerID" />
                            </ParentTableRelation>
                            <Columns>
                                <telerik:GridBoundColumn SortExpression="OrderID" HeaderText="OrderID" HeaderButtonType="TextButton"
                                    DataField="OrderID" UniqueName="OrderID" ReadOnly="True" Display="False">
                                </telerik:GridBoundColumn>
                                <telerik:GridBoundColumn SortExpression="ShipName" HeaderText="Ship name" HeaderButtonType="TextButton"
                                    DataField="ShipName" UniqueName="ShipName">
                                </telerik:GridBoundColumn>
                                <telerik:GridBoundColumn SortExpression="ShipVia" HeaderText="Ship via" HeaderButtonType="TextButton"
                                    DataField="ShipVia" UniqueName="ShipVia" />
                            </Columns>
                        </telerik:GridTableView>
                    </DetailTables>
                    <Columns>
                        <telerik:GridBoundColumn SortExpression="CustomerID" HeaderText="CustomerID" HeaderButtonType="TextButton"
                            DataField="CustomerID" UniqueName="CustomerID" ReadOnly="True" Display="False">
                        </telerik:GridBoundColumn>
                        <telerik:GridBoundColumn SortExpression="CompanyName" HeaderText="Company name" HeaderButtonType="TextButton"
                            DataField="CompanyName" UniqueName="CompanyName">
                        </telerik:GridBoundColumn>
                        <telerik:GridBoundColumn SortExpression="ContactName" HeaderText="Contact name" HeaderButtonType="TextButton"
                            DataField="ContactName" UniqueName="ContactName">
                        </telerik:GridBoundColumn>
                    </Columns>
                </MasterTableView>
                <ClientSettings>
                    <ClientEvents OnRowClick="RowClick" OnRowDblClick="RowDblClick"
                        OnRowCreated="RowCreated"></ClientEvents>
                </ClientSettings>
            </telerik:RadGrid>
            
            <asp:AccessDataSource ID="AccessDataSource1" runat="server" ConflictDetection="CompareAllValues"
                DataFile="~/App_Data/Nwind.mdb" OldValuesParameterFormatString="original_{0}"
                SelectCommand="SELECT [CustomerID], [ContactName], [CompanyName] FROM [Customers]"
                UpdateCommand="UPDATE [Customers] SET [ContactName] = ?, [CompanyName] = ? WHERE [CustomerID] = ? AND [ContactName] = ? AND [CompanyName] = ?">
                <UpdateParameters>
                    <asp:Parameter Name="ContactName" Type="String" />
                    <asp:Parameter Name="CompanyName" Type="String" />
                    <asp:Parameter Name="original_CustomerID" Type="String" />
                    <asp:Parameter Name="original_ContactName" Type="String" />
                    <asp:Parameter Name="original_CompanyName" Type="String" />
                </UpdateParameters>
            </asp:AccessDataSource>
            <asp:AccessDataSource ID="AccessDataSource2" runat="server" ConflictDetection="CompareAllValues"
                DataFile="~/App_Data/Nwind.mdb" OldValuesParameterFormatString="original_{0}"
                SelectCommand="SELECT * FROM Orders Where CustomerID = ?" UpdateCommand="UPDATE [Orders] SET [ShipVia] = ?, [ShipName] = ? WHERE [OrderID] = ? AND [ShipVia] = ? AND [ShipName] = ?">
                <SelectParameters>
                    <asp:SessionParameter Name="CustomerID" SessionField="CustomerID" Type="string" />
                </SelectParameters>
                <UpdateParameters>
                    <asp:Parameter Name="ShipVia" Type="Int32" />
                    <asp:Parameter Name="ShipName" Type="String" />
                    <asp:Parameter Name="original_OrderID" Type="String" />
                    <asp:Parameter Name="original_ShipVia" Type="Int32" />
                    <asp:Parameter Name="original_ShipName" Type="String" />
                </UpdateParameters>
            </asp:AccessDataSource>
            
        </div>
    </form>
</body>
</html>
